import * as React from 'react';
import { BasketData, BasketItem } from '../basket-data';
export interface DataProvider {
    getInitialData(): Promise<BasketItem[]>;
    onAllItemsDeleted(): Promise<BasketItem[]>;
    onItemAdded(id: string): Promise<BasketItem[]>;
    onItemDeleted(id: string): Promise<BasketItem[]>;
    registerToChanges(callback: (items: BasketItem[]) => void): any;
}
export interface BasketProviderProps {
    dataProvider: DataProvider;
}
export declare class BasketProvider extends React.Component<BasketProviderProps, BasketData> {
    constructor(props: BasketProviderProps);
    componentWillMount(): void;
    componentDidMount(): void;
    onAllItemsAdded: () => void;
    onItemAdded: (id: string) => void;
    onItemDeleted: (id: string) => void;
    render(): JSX.Element;
}
