"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var __1 = require("../");
var BasketProvider = /** @class */ (function (_super) {
    __extends(BasketProvider, _super);
    function BasketProvider(props) {
        var _this = _super.call(this, props) || this;
        _this.onAllItemsAdded = function () {
            _this.setState({ isLoading: true }, function () {
                _this.props.dataProvider.onAllItemsDeleted()
                    .then(function (items) {
                    _this.setState({ items: items, isLoading: false });
                });
            });
        };
        _this.onItemAdded = function (id) {
            _this.setState({ isLoading: true }, function () {
                _this.props.dataProvider.onItemAdded(id)
                    .then(function (items) {
                    _this.setState({ items: items, isLoading: false });
                });
            });
        };
        _this.onItemDeleted = function (id) {
            _this.setState({ isLoading: true }, function () {
                _this.props.dataProvider.onItemDeleted(id)
                    .then(function (items) {
                    _this.setState({ items: items, isLoading: false });
                });
            });
        };
        _this.state = {
            isLoading: false,
            items: [],
            onAllItemsDeleted: _this.onAllItemsAdded,
            onItemAdded: _this.onItemAdded,
            onItemDeleted: _this.onItemDeleted,
        };
        return _this;
    }
    BasketProvider.prototype.componentWillMount = function () {
        var _this = this;
        this.props.dataProvider.registerToChanges(function (items) {
            _this.setState({ items: items });
        });
    };
    BasketProvider.prototype.componentDidMount = function () {
        var _this = this;
        this.setState({ isLoading: true }, function () {
            _this.props.dataProvider.getInitialData()
                .then(function (items) {
                _this.setState({ items: items, isLoading: false });
            });
        });
    };
    BasketProvider.prototype.render = function () {
        return (React.createElement(__1.BasketContext.Provider, { value: this.state }, this.props.children));
    };
    return BasketProvider;
}(React.Component));
exports.BasketProvider = BasketProvider;
