"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var core_1 = require("@material-ui/core");
var material_table_1 = __importDefault(require("material-table"));
var DeleteOutline_1 = __importDefault(require("@material-ui/icons/DeleteOutline"));
var basket_context_1 = require("../basket-context");
var BasketInner = /** @class */ (function (_super) {
    __extends(BasketInner, _super);
    function BasketInner() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    BasketInner.prototype.render = function () {
        var _this = this;
        return (React.createElement(core_1.Card, { elevation: 0 },
            React.createElement(core_1.CardContent, { style: { padding: 0 } },
                React.createElement(material_table_1.default, { components: {
                        Container: function (props) { return React.createElement(core_1.Paper, __assign({}, props, { elevation: 0 })); }
                    }, isLoading: this.props.basketData.isLoading, title: "Shopping Cart", data: this.props.basketData.items, actions: [
                        {
                            icon: function () { return React.createElement(DeleteOutline_1.default, null); },
                            tooltip: 'Delete Item(s)',
                            onClick: function (e, rowData) {
                                _this.props.basketData.onItemDeleted(rowData.id);
                            }
                        },
                        {
                            icon: function () { return React.createElement(DeleteOutline_1.default, null); },
                            tooltip: 'Delete All Item',
                            onClick: function () {
                                _this.props.basketData.onAllItemsDeleted();
                            },
                            isFreeAction: true
                        }
                    ], columns: [
                        { title: 'Product', field: 'name' },
                        { title: 'Quantity', field: 'quantity', type: 'numeric' },
                        { title: 'Price', field: 'price', type: 'currency' },
                    ], options: {
                        actionsColumnIndex: -1,
                        emptyRowsWhenPaging: false,
                        paging: false,
                        search: false
                    }, localization: {
                        body: {
                            emptyDataSourceMessage: 'No item in your shopping cart'
                        },
                        header: {
                            actions: ''
                        }
                    } }),
                React.createElement("div", { style: { padding: '10px 20px 10px 10px', textAlign: 'right' } })),
            React.createElement(core_1.CardActions, { style: { justifyContent: "flex-end" } },
                React.createElement(core_1.Typography, { variant: "title", style: { marginRight: 10 } }, "Total: $1987.22"),
                React.createElement(core_1.Button, { variant: "outlined", color: "primary", style: { textTransform: 'none' } }, "Payment"))));
    };
    return BasketInner;
}(React.Component));
exports.Basket = basket_context_1.withBasketData(BasketInner);
